%
% 
% Kernel PCA program for octave or matlab
%
% 2000/1/8 Taku Kudoh
%

% Generalized Kernel Func (The same idea of GSVM)
%function mat = Kernel (u,v)
%  % polynomial
%  mat = (u * v' + 1) .^2;
% RBF
%  mat = exp( -(  sum(u .^ 2 ')' * ones(1,size(v,1)) + (sum(v .^ 2 ')' * ones(1,size(u,1)))' - 2 * u * v' ) /5000);
%  mat = exp( -(  sum(u .^ 2 ')' * ones(1,size(v,1)) + (sum(v .^ 2 ')' * ones(1,size(u,1)))' - 2 * u * v' ) /5000);
%endfunction

% main
%disp "Loading Training Data ...";
load train;
train_num  = size(train, 1);
unit_train = ones(train_num, train_num)/train_num;
K_train    = Kernel(train, train);
K_train_n  = K_train - unit_train * K_train - K_train * unit_train + unit_train * K_train * unit_train;

%disp "Loading Test Data ...";
load test;
test_num  = size(test, 1);
unit_test = ones(test_num,train_num)/train_num;
K_test    = Kernel(test, train);
K_test_n  = K_test - unit_test * K_train - K_test * unit_train + unit_test * K_train * unit_train;

%disp "Calculating Eigenvalue ....";
[evecs_n, evals]   = eig(K_train_n/train_num);
[evals,   evals_o] = sort(real(diag(evals)));
evals_o = rot90(evals_o, -2); 
evals   = rot90(evals,   -2);

%disp "Normlizing Eiginvector ....";
evecs = zeros(train_num,train_num);
for i = 1 : train_num,
  evecs(:,i) = real(evecs_n(:,evals_o(i,1))/sqrt(evals(i,1)));
end
evecs_n = [];

%disp "Making Feature Vector ..."
train_features = K_train_n * evecs;
test_features  = K_test_n  * evecs;

%disp "Saving All Value .."
save -ascii 'K_test_n'       K_test_n;
save -ascii 'K_train_n'      K_train_n;
save -ascii 'evecs'          evecs;
save -ascii 'evals'          evals;
save -ascii 'train_features' train_features;
save -ascii 'test_features'  test_features;

%disp "Done!"

